unit Unit2;

interface

uses
  SysUtils, Classes, graphics, ImgList, Controls;

type
  TdtmComments = class(TDataModule)
    ImageList1: TImageList;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    backgroundimage : TBitmap;
    procedure addComment(step : integer);
    procedure startComment;
    procedure unhappyComment;
    procedure instructions;
    procedure nextInstructions;
    procedure level2Comment;
    procedure level3Comment;
    procedure finalInstructions;
    procedure won;
    procedure finalScreen;
    procedure sacking;
    function checkForNextComments(comment : integer) : integer;    
  end;

var
  dtmComments: TdtmComments;

implementation

{$R *.dfm}

function TdtmComments.checkForNextComments(comment : integer) : integer;
begin
  if comment = 0 then
    result := 1
  else if comment = 1 then
    result := 2
  else if comment = 3 then
    result := 4
  else if comment = 7 then
    result := 8
  else
    result := 0;
end;

procedure TdtmComments.sacking;
begin
  imagelist1.Draw(backgroundimage.Canvas,20,150,0);
  imagelist1.Draw(backgroundimage.Canvas,500,100,1);
  imagelist1.Draw(backgroundimage.Canvas,500,200,3);
  with backgroundimage.Canvas do begin
    font.Color := clRed;
    textout(100,120,'Hail tiny minions!');
    textout(100,180,'You are rubbish. Sling you hooks.');

    font.Color := clLime;
    textout(100,150,'Hail mighty king Zog!');
    textout(100,210,'Thank goodness that is over.');
  end;
end;

procedure TdtmComments.finalScreen;
var tempBitmap : TBitmap;
begin
  imagelist1.Draw(backgroundimage.Canvas,20,150,0);
  imagelist1.Draw(backgroundimage.Canvas,500,100,1);
  imagelist1.Draw(backgroundimage.Canvas,500,200,3);
  with backgroundimage.Canvas do begin
    font.Color := clRed;
    textout(100,120,'Hail tiny minions!');
    textout(100,180,'You have served me well. As a');
    textout(100,210,'reward you may now bear my');
    textout(100,240,'children.');

    font.Color := clLime;
    textout(100,150,'Hail mighty king Zog!');
    textout(100,270,'Oh no! I think now is time to');
    textout(100,300,'restart the game! Well done.');
  end;
end;

procedure TdtmComments.instructions;
var tempBitmap : TBitmap;
begin
  with backgroundimage.Canvas do begin
    font.Color := clWhite;
    textout(20,10,'The pocket universe is the place in the cracks of time and');
    textout(10,40,'space where forgotten objects go. Traffic cones, boxes, ');
    textout(10,70,'juke boxes all end up here.');

    textout(20,110,'Over time this matter has condensed and formed islands in');
    textout(10,140,'space. Each island world has its own king. The focus of');
    textout(10,170,'this game is King Zog.');

    textout(20,210,'King Zog is fond of starflower seeds, which grow on some');
    textout(10,240,'of his islands. He sends his two servants, Phil and Stu. It is');
    textout(10,270,'a universal constant that all service departments have a');
    textout(10,300,'Stu and Phil working in it.');
  end;
  imagelist1.Draw(backgroundimage.Canvas,20,335,0);
  imagelist1.Draw(backgroundimage.Canvas,300,335,5);
  imagelist1.Draw(backgroundimage.Canvas,400,335,3);
end;

procedure TdtmComments.nextInstructions;
var tempBitmap : TBitmap;
begin
  with backgroundimage.Canvas do begin
    font.Color := clWhite;
    textout(20,10,'The starflower grows whilst basking in the sun of the');
    textout(10,40,'local island. Once ready for harvesting, it will only ');
    textout(10,70,'give up its seeds once it is in shadow.');

    textout(20,110,'Being the short arses that they are, Phil and Stu must');
    textout(10,140,'block the light off from each flower in order to force');
    textout(10,170,'the plant to shed its seed. They achieve this by ');
    textout(10,200,'stacking up objects until the shadow falls on the flower.');

    textout(20,240,'Once in shade, the flower will start to rotate. Once it');
    textout(10,270,'has been in shade for a sufficient time the seeds will be');
    textout(10,300,'release and Stu and Phil can go on to the next island.');
  end;
end;

procedure TdtmComments.finalInstructions;
var tempBitmap : TBitmap;
begin
  with backgroundimage.Canvas do begin
    font.Color := clWhite;
    textout(20,10,'Phil and Stu have a finite amount of detrious on each');
    textout(10,40,'island, using whatever lost item is floating by. There ');
    textout(10,70,'is a surprising amount of teachests available.');

    textout(20,110,'The drop zone for an object is guided by swishing the');
    textout(10,140,'mouse to guide the control column. Pressing 1 will ');
    textout(10,170,'drop a teachest, 2 will drop a safe and 3 will drop a  ');
    textout(10,200,'jukebox. Pressing delete and pointing will collect an ');
    textout(10,230,'item and return it to the available items.');

    textout(20,270,'Any object going over the edge will be lost if you ');
    textout(10,300,'don''t grab them in time. King Zog has given 5 ');
    textout(10,330,'minutes to complete each level. Or else its out.');
    textout(10,360,'with the P45 for our intrepid duo.');
  end;
end;

procedure TdtmComments.startComment;
var tempBitmap : TBitmap;
begin
  imagelist1.Draw(backgroundimage.Canvas,20,150,0);
  imagelist1.Draw(backgroundimage.Canvas,500,100,1);
  imagelist1.Draw(backgroundimage.Canvas,500,200,3);
  with backgroundimage.Canvas do begin
    font.Color := clRed;
    textout(100,120,'Hail tiny minions!');
    textout(100,180,'Go and collect my starflower seeds!');

    font.Color := clLime;
    textout(100,150,'Hail mighty king Zog!');
    textout(100,210,'Zog lead, we follow!');
  end;
end;

procedure TdtmComments.unhappyComment;
var tempBitmap : TBitmap;
begin
  imagelist1.Draw(backgroundimage.Canvas,20,150,5);
  imagelist1.Draw(backgroundimage.Canvas,500,150,4);
  with backgroundimage.Canvas do begin
    font.Color := clRed;
    textout(100,120,'Ye gods, hes a berk!');
    textout(100,180,'Out first destination is an easy');
    textout(100,210,'low plant with lots of teachests.');
    textout(100,240,'We just need a large pile.');

    font.Color := clBlue;
    textout(100,150,'That he is Stu. Lets get going.');
    textout(100,270,'Sounds easy enough.');
  end;
end;

procedure TdtmComments.level2Comment;
var tempBitmap : TBitmap;
begin
  imagelist1.Draw(backgroundimage.Canvas,20,150,5);
  imagelist1.Draw(backgroundimage.Canvas,500,150,4);
  with backgroundimage.Canvas do begin
    font.Color := clRed;
    textout(100,120,'That was easy.');
    textout(100,180,'Dunno. Maybe they are looking at the');
    textout(100,210,'pretty view and graphics rather than');
    textout(100,240,'the game.');
    textout(100,330,'And the author had bothered to read up');
    textout(100,360,'on the physics library.');

    font.Color := clBlue;
    textout(100,150,'Do you think anybody has played this far?.');
    textout(100,270,'I hope so. It had promise if there was more');
    textout(100,300,'than 48 hours to play with.');
  end;
end;

procedure TdtmComments.won;
var tempBitmap : TBitmap;
begin
  imagelist1.Draw(backgroundimage.Canvas,20,150,5);
  imagelist1.Draw(backgroundimage.Canvas,500,150,4);
  with backgroundimage.Canvas do begin
    font.Color := clRed;
    textout(100,120,'So what happens next?.');

    font.Color := clBlue;
    textout(100,150,'Shhh. Something is approaching.');
  end;
end;

procedure TdtmComments.level3Comment;
var tempBitmap : TBitmap;
begin
  imagelist1.Draw(backgroundimage.Canvas,20,150,5);
  imagelist1.Draw(backgroundimage.Canvas,500,150,4);
  with backgroundimage.Canvas do begin
    font.Color := clRed;
    textout(100,120,'That was harder.');
    textout(100,240,'Have to say, this game is a good idea.');
    textout(100,270,'Its just a shame that we couldn''t get');
    textout(100,300,'the library to handle more complicated');
    textout(100,330,'shapes.');

    font.Color := clBlue;
    textout(100,150,'We get jukeboxes on the next level. Lets');
    textout(100,180,'see how far down we can push the framerate.');
    textout(100,210,'than 48 hours to play with.');
    textout(100,360,'Never mind. Lets rock.');
  end;
end;

procedure TdtmComments.addComment(step : integer);
begin
  backGroundImage.Canvas.FillRect(rect(0,0,600,400));
  backGroundImage.Canvas.Pen.Color := clRed;
  backGroundImage.Canvas.Rectangle(rect(1,1,598,398));
  case step of
    0 : instructions;
    1 : nextinstructions;
    2 : finalinstructions;
    3 : startComment;
    4 : unhappyComment;
    5 : level2Comment;
    6 : level3Comment;
    7 : won;
    8 : finalScreen;
    9 : sacking;
  end;
//  finalInstructions;
end;

procedure TdtmComments.DataModuleCreate(Sender: TObject);
begin
  backgroundimage := TBitmap.create;
  backgroundimage.Width := 600;
  backgroundimage.height := 400;
  backgroundimage.Canvas.Brush.Color := clBlack;
  backgroundimage.Canvas.Font.Size := 18;
  backgroundimage.Canvas.Font.Name := 'Times New Roman';
end;

procedure TdtmComments.DataModuleDestroy(Sender: TObject);
begin
  backgroundimage.free;
end;

end.
